// Dieses Script macht eine Ansage, wie wir sie aus Quake III kennen:
// "You have taken the lead!"
// "You were tied for the lead!"
// "You have lost the lead!"
// Der say-Befehl /lead zeigt den aktuellen Leader an.
//
// Die CVars amx_lead_minkills gibt an, ab wieviel Kills das Script aktiv wird, um eine uebermaessige
// Ausgabe von Sounds am Rundenbeginn zu vermeiden.
//
// Die CVars amx_lead_leadername, amx_lead_leaderuid und amx_lead_leaderkills speichern Namen, UID und Kills des besten.
// Wenn es keinen Leader gibt, ist amx_lead_leadername = 0.
// Wenn es mehrere gibt, gibt amx_lead_leadername die Anzahl wieder.
// Diese CVars sind dazu gedacht, anderen Scripts den Leader anzugeben.
// Wenn man sie per Konsolenbefehl aendert, wird dies auf dieses Script keinerlei Auswirkung haben!!!
//
// Idea & Scripting by [SWz]MistaGee
// http://www.mistagee.de
// Have fun with it!

#include <amxmodx>
#include <amxmisc>
#include <csx>

new PLUGIN[] = "Q3A Lead Announcement"
new VERSION[] = "3.1"
new AUTHOR[] = "MistaGee"

// Bomben-Funktions-Aktivierungs-CVar
// 1 = aktiv, 0 = Inaktiv
#define CHECKBOMBE "1"

public plugin_init(){
	register_plugin(PLUGIN, VERSION, AUTHOR)

	register_cvar("amx_lead_minkills", "3")
	register_cvar("amx_lead_leadername", "0")
	register_cvar("amx_lead_leaderkills", "0")
	register_cvar("amx_lead_leaderuid", "0")
	
	register_concmd("say /lead", "cmd_saylead", -1, "Say /lead to see who's the leader in the moment")
	
	register_event("DeathMsg", "cmd_lead_check", "a")
	register_event("TextMsg", "cmd_restartgame", "a", "2=#Game_Commencing", "2=#Game_will_restart_in")
	
	// Bomben-Zaehler-Aktivierungs-CVar
	register_cvar("amx_lead_countbomb", CHECKBOMBE);
	
	// Sprachbuch (-.-) registrieren
	register_dictionary("q3a_lead.txt");
	}

public plugin_precache(){
	// Sounds precachen, damit Clients, die sie nicht haben, sie saugen
	precache_sound("misc/takenlead.wav")	// Nur wegen Saugen geprechachet
	precache_sound("misc/tiedlead.wav")		// Nur wegen Saugen geprechachet
	precache_sound("misc/lostlead.wav")		// Nur wegen Saugen geprechachet
	precache_sound("misc/theone.wav")		// Wird wirklich gebraucht! NICHT ENTFERNEN!!!
	}
	
new maxkills, maxkills_uid[32], hudmsg_username[32], leader_name[32]
const zero_target = 0

public cmd_lead_check(some_strange_id){
	
	// User-ID von Killer & Opfer auslesen
	new killerID = read_data(1) // Killer

	if(get_user_team(killerID) == get_user_team(read_data(2))){ // TK oder selbst angegriffen >:-( (Opfer & Killer im gleichen Team)
		cmd_calclead((get_user_frags(killerID) - 1), killerID)
		} // WENN :: TK oder sich selbst gelegt
	else{
		cmd_calclead((get_user_frags(killerID) + 1), killerID)
		} // SONST :: Normaler Kill, wie das sein soll :]
	return PLUGIN_CONTINUE;	
	}	 // Funktion :: cmd_lead_check
	

public bool:cmd_calclead(playerkills, kID){ // Lead pruefen	
	// Abbruchbedingungen
	if((playerkills < get_cvar_num("amx_lead_minkills")) ||	// Minkills nicht erreicht
		(playerkills < maxkills))							// Maxkills der anderen unterschritten
		return true;//if
	
	if(playerkills > maxkills){ // Unser Mann ist der neue Chief
		// Wenn der Mensch schonmal die Fuehrung geholt hat, is alles m'kaaaaaaaaaaaaaaaaaaaaaaaay
		// dann muessen nur noch die Maxkills angepasst werden, und schon sind wir gluecklich!
		if((maxkills_uid[0] == kID) && (array_count(maxkills_uid, 32) == 1)){
			maxkills = playerkills
			return true
			}//if
		
		// Allen bisherigen Usern sagen, dass sie die Fuehrung vergessen koennen - abgesehen vom neuen Leader
		for(new p = 0; p < 32; p++){
			if((maxkills_uid[p] > 0) && (maxkills_uid[p] != kID)){
				client_cmd(maxkills_uid[p], "spk misc/lostlead.wav")
				}//if
			}//for

		// Dem Spieler sagen, dass er Big Daddy ist
		if(kID > 0){ // Sound darf nicht an alle gehen - das nervt
			client_cmd(kID, "spk misc/takenlead.wav")
		}//if
		
		// HUD-Msg an alle
		set_hudmessage(255, 0, 0, -1.0, 0.8, 1, 6.0, 6.0, 1.0, 1.0, 2)
		get_user_name(kID, hudmsg_username, 31)
		show_hudmessage(zero_target, "%L", LANG_PLAYER, "TAKENLEAD", hudmsg_username, playerkills)
		
		// Neuen Leader als einzigen ins Leader-Array schreiben, Rest mit 0en fuellen
		maxkills = playerkills
		maxkills_uid[0] = kID
		array_fillzero(maxkills_uid, 32, 1)
		
		// CVars setzen
		set_cvar_string("amx_lead_leadername", hudmsg_username)	// Nick des Leaders
		set_cvar_num("amx_lead_leaderuid", kID)					// UID
		set_cvar_num("amx_lead_leaderkills", playerkills)		// Kills
		}//if
	
	else if(playerkills == maxkills){
		// Unser Mann muss ins Leader-Array aufgenommen werden
		add_to_array(maxkills_uid, 32, kID)
		new test_uid = 0
		for(new i = 0; i < 32; i++){
			test_uid = maxkills_uid[i]
			if(test_uid > 0){
				client_cmd(test_uid, "spk misc/tiedlead.wav")
				if(test_uid == kID){ // Killer kriegt eine eigene Nachricht
					if(array_count(maxkills_uid, 32) == 2){ // Wenn jetz nur 2 Leutz drinstehn, muss Nr0 der bisherige Leader sein, da unser Mann jetzt als Nr1 drinsteht!
						get_user_name(maxkills_uid[0], leader_name, 31)
						set_hudmessage(255, 0, 0, -1.0, 0.8, 1, 6.0, 6.0, 1.0, 1.0, 2)
						show_hudmessage(test_uid, "%L", test_uid, "CATCHUP_SINGLE", leader_name)
						}//if
					else{ // Schade, es gibt mehr als 2 Leutz im Array
						set_hudmessage(255, 0, 0, -1.0, 0.8, 1, 6.0, 6.0, 1.0, 1.0, 2)
						show_hudmessage(test_uid, "%L", test_uid, "CATCHUP_MULTI")
						}//else
					}//if
				else{ // Bisherige Leader werden ueber die Konkurrenz informiert
					set_hudmessage(255, 0, 0, -1.0, 0.8, 1, 6.0, 6.0, 1.0, 1.0, 2)
					get_user_name(kID, hudmsg_username, 31)
					show_hudmessage(test_uid, "%L", test_uid, "CATCHUP_BY", hudmsg_username)
					}//else
				}//if
			}//for
		
		// CVars setzen
		set_cvar_num("amx_lead_leadername", array_count(maxkills_uid, 32))	// Anzahl der Leader
		set_cvar_num("amx_lead_leaderuid", kID)								// UID des letzten
		set_cvar_num("amx_lead_leaderkills", playerkills)					// Kills

		}//else if
	return true
	} // Funktion cmd_calclead

public client_disconnect(id){
	// Init
	new bool:pl_leader = false
	new bool:pl_onlyleader = false
	
	// Pruefen, ob der disconnectende Player (einer) der Leader war
	if(array_in(maxkills_uid, id, 32)){ // Fuer noch keine Leader ist das Array leer, also steht auch der Spieler net drin!
		// Wenn der Typ im Array steht, war er einer
		pl_leader = true
		// Bleibt noch festzustellen, ob er der einzige war
		if(array_count(maxkills_uid,32) == 1){	// Jap
			pl_onlyleader = true
			}//if
		else{									// Nope
			pl_onlyleader = false
			}//else
		}//if
	
	// Spieler-IDs auslesen
	new players[32], num, plmaxkills, j, plkills
	get_players(players, num)
	
	// Maxkills-UID-Array neu fuellen
	for(j = 0; j < num; j++){
		if(!(players[j] == id)){ // Sicherheit, das wir den Disconnecter nicht wieder mit eintragen!
			plkills = get_user_frags(players[j])
			if(plkills > plmaxkills){
				plmaxkills = plkills
				maxkills_uid[0] = players[j]
				array_fillzero(maxkills_uid, 32, 1)
				}//if
			else if(plkills == plmaxkills){
				add_to_array(maxkills_uid, 32, players[j])
				}//else if
			}//if
		}//for
	
	if(pl_leader){
		// Der disconnectende Player war Leader. Was ist zu tun?
		// Anzahl der neuen Leader pruefen, wenn's nur einer ist, erhaelt dieser "Taken the lead"
		// Wenn's mehere sind und der Discer HIGHLANDER war, erhalten alle "Tied for the lead"
		// Wenn der Discer KEIN Highlander war, passiert nix, weil sich fuer die anderen nichts geaendert hat!
		
		if(array_count(maxkills_uid, 32) == 1){
			client_cmd(maxkills_uid[0], "spk misc/takenlead")
			// HUD-Msg an alle
			set_hudmessage(255, 0, 0, -1.0, 0.8, 1, 6.0, 6.0, 1.0, 1.0, 2)
			get_user_name(maxkills_uid[0], hudmsg_username, 31)
			show_hudmessage(zero_target, "%L", LANG_PLAYER, "TAKENLEAD", hudmsg_username, get_user_frags(maxkills_uid[0]))
			}//if
		else if(pl_onlyleader){
			for(j = 0; j < array_count(maxkills_uid, 32); j++){
				client_cmd(maxkills_uid[j], "spk misc/tiedlead")
				// HUD-Msg an alle Tied-Leader
				set_hudmessage(255, 0, 0, -1.0, 0.8, 1, 6.0, 6.0, 1.0, 1.0, 2)
				show_hudmessage(maxkills_uid[j], "%L", maxkills_uid[j], "TIED_AFTER_DSC")
				}//for
			}//else if
		}//if
			
	return PLUGIN_CONTINUE
	} // Funktion client_disconnect


public cmd_saylead(userID, userlevel, cID){
	new plmax_num = array_count(maxkills_uid, 32)
	if(plmax_num > 1){ // Mehrere kaempfen ums Lead
		if((plmax_num == 2) && (array_in(maxkills_uid, userID, 32))){ // Wenn 2 ums Lead kaempfen und unser Mann dabei ist, Ausgeben!
			// Wir haben zwei Leutz im Array - Nr0 und Nr1. Ich brauche die, die unser Mann NICHT ist, also
			// 1 - array_in_pos(Unser_Mann)
			new competitorSlot = 1 - array_in_pos(maxkills_uid, userID, 32)
			new competitorUID = maxkills_uid[competitorSlot]
			new competitorName[32]
			get_user_name(competitorUID, competitorName, 31)
			set_hudmessage(255, 0, 0, -1.0, 0.8, 1, 6.0, 6.0, 1.0, 1.0, 2)
			show_hudmessage(userID, "%L", userID, "TIE_WITH", competitorName, maxkills)
			}//if
		else{
			set_hudmessage(255, 0, 0, -1.0, 0.8, 1, 6.0, 6.0, 1.0, 1.0, 2)
			show_hudmessage(userID, "%L", userID, "PLNUM_TIED", plmax_num, maxkills)
			}//else
		}//if
	else if(plmax_num == 1){ // Genau ein Leader = Highlander!
		if(maxkills_uid[0] == userID){ // wenn unser Cheffe der Leader ist:
			set_hudmessage(255, 0, 0, -1.0, 0.8, 1, 6.0, 6.0, 1.0, 1.0, 2)
			show_hudmessage(userID, "%L", userID, "ULEAD", get_user_frags(maxkills_uid[0]))
			// Client singt laut "I am the one and only"
			client_cmd(userID, "spk misc/theone.wav")
			if(is_user_alive(userID)){ // Wenn der Spieler nicht lebt, der den Toggle aufruft, nichts machen --> sonst verraeterisch, weil das Gesinge die Position z.B. hinter einer Kiste preisgibt
				emit_sound(userID, CHAN_AUTO, "misc/theone.wav", 1.0, ATTN_NORM, 0, PITCH_HIGH);} // Alle sollen es hoeren!
			}//if
		else{ // Wenn er nicht der Leader ist, dessen Name anzeigen
			set_hudmessage(255, 0, 0, -1.0, 0.8, 1, 6.0, 6.0, 1.0, 1.0, 2)
			get_user_name(maxkills_uid[0], hudmsg_username, 31)
			show_hudmessage(userID, "%L", userID, "ONELEAD", hudmsg_username, get_user_frags(maxkills_uid[0]))
			}//else
		}//else if
	else{ // Schade -  noch kein leader vorhanden
		set_hudmessage(255, 0, 0, -1.0, 0.8, 1, 6.0, 6.0, 1.0, 1.0, 2)
		show_hudmessage(userID, "%L", userID, "NOLEAD")
		}//else
	return PLUGIN_CONTINUE
	} // Funktion cmd_saylead
	
public bomb_explode(planter, defuser){
	if(get_cvar_num("amx_lead_countbomb")) // Nur wenn's erlaubt is
		cmd_calclead((get_user_frags(planter)), planter);
	} // Funktion :: Bombe explodiert

public bomb_defused(defuser){
	if(get_cvar_num("amx_lead_countbomb")) // Nur wenn's erlaubt is
		cmd_calclead((get_user_frags(defuser)), defuser);
	} // Funktion :: Bombe entschaerft

public cmd_restartgame(){
	// Alle Einstellungen zuruecksetzen
	maxkills = 0
	array_fillzero(maxkills_uid, 32, 0)
	return PLUGIN_CONTINUE
	} // Funktion cmd_restartgame

bool:array_fillzero(array[], const len, const val){
	for(new z = val; z < len; z++){
		array[z] = 0
		}//for
	return true
	} // Funktion array_fillzero

add_to_array(array[], const len, const val){
	for(new w = 0; w < len; w++){
		if(array[w] == 0){
			array[w] = val
			return w
			}//if
		}//for
	return -1 // Array ist voll!
	} // Funktion add_to_array

array_count(const array[], const len){
	new array_num = 0
	for(new c = 0; c < len; c++){
		if(array[c] > 0){
			array_num++
			}//if
		}//for
	return array_num
	} // array_count

bool:array_in(const array[], const val, const len){
	new l = 0
	for(l = 0; l < len; l++){
		// Wenn val im Array gefunden wird, true zurueckgeben und Funktion beenden
		if(array[l] == val){return true;}//if
		}//for
	// Val wurde nicht im Array gefunden, also false zurueckgeben
	return false
	} // array_in

array_in_pos(const array[], const val, const len){
	new l = 0
	for(l = 0; l < len; l++){
		// Wenn val im Array gefunden wird, Stelle zurueckgeben und Funktion beenden
		if(array[l] == val){return l;}//if
		}//for
	// Val wurde nicht im Array gefunden, also -1 zurueckgeben
	return -1
	} // array_in_pos

//	new msg[128]
//	format(msg,127,"%s hat mit %d Kills die Fuehrung uebernommen!", get_user_name(maxkills_uid), maxkills)
//	set_hudmessage(255, 255, 255, -1.0, 0.30, 0, 6.0, 6.0, 0.5, 0.15, 3)
//	show_hudmessage(0, msg) // ID=0 shows message to everyone
